%global _hardened_build	1

%if 0%{?rhel} >= 7
%global _with_systemd	1
%endif
%if 0%{?fedora}
%global _with_systemd	1
%endif

%{?el5:%global _udevrulesdir /etc/udev/rules.d}
%{?el6:%global _udevrulesdir /lib/udev/rules.d}

Name:		srcpd
Version:	2.1.2
Release:	5%{?dist}
Summary:	Simple Railroad Command Protocol (SRCP) server

Group:		System Environment/Daemons
License:	GPLv2
URL:		http://srcpd.sourceforge.net/
Source0:	http://sourceforge.net/projects/srcpd/files/srcpd/%{version}/srcpd-%{version}.tar.gz
Source1:	srcpd.service
Source2:	srcpd.init

%{?el5:BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-root}

# Compile errors (missing sys/io.h) on secondary architectures
ExclusiveArch: %{ix86} %{arm} x86_64

BuildRequires:	libxml2-devel

%if 0%{?_with_systemd}
Requires(post):		systemd
Requires(preun):	systemd
Requires(postun):	systemd
BuildRequires:		systemd
%else
Requires(post):		chkconfig
Requires(preun):	chkconfig
Requires(preun):	initscripts
Requires(postun):	initscripts
%endif


%description
Simple Railroad Command Protocol (SRCP) is a communication protocol designed
to integrate various models of railroad systems. The srcpd acts a gateway
between any kind of model railway systems and user interface programs that
support SRCP. IANA assigned TCP port 4303 to it.


%prep
%setup -q
for file in ./man/de/srcpd.* ./DESIGN ./README; do
  iconv -f latin1 -t utf8 < $file > $file.new
  mv -f $file.new $file
done


%build
%configure
make %{?_smp_mflags}


%install
%if 0%{?el5}
rm -rf %{buildroot}
%endif
make install DESTDIR=%{buildroot}
%{!?el5:%find_lang %{name} --with-man --all-name}

%if 0%{?_with_systemd}
install -Dpm 0644 %SOURCE1 %{buildroot}/%{_unitdir}/srcpd.service
%else
install -Dpm 0755 %SOURCE2 %{buildroot}/%{_initrddir}/srcpd
%endif
rm -rf %{buildroot}/%{_sysconfdir}/udev
install -Dpm 0644 10-liusb.rules %{buildroot}/%{_udevrulesdir}/10-liusb.rules


%if 0%{?el5}
%clean
rm -rf %{buildroot}
%endif


%post
%if 0%{?_with_systemd}
%systemd_post %{name}.service
%else
/sbin/chkconfig --add srcpd
%endif
exit 0

%preun
%if 0%{?_with_systemd}
%systemd_preun %{name}.service
%else
if [ $1 = 0 ]; then
	/sbin/service srcpd stop > /dev/null 2>&1
	/sbin/chkconfig --del srcpd
fi
%endif
exit 0

%postun
%if 0%{?_with_systemd}
%systemd_postun_with_restart %{name}.service
%else
if [ "$1" -ge "1" ]; then
	/sbin/service srcpd condrestart > /dev/null 2>&1
fi
%endif
exit 0


%files %{!?el5: -f %{name}.lang}
%defattr(-,root,root,-)
%doc AUTHORS COPYING ChangeLog DESIGN NEWS PROGRAMMING-HOWTO TODO
%doc README README.loconet README.selectrix
%config(noreplace) %{_sysconfdir}/srcpd.conf
%config(noreplace) %{_udevrulesdir}/10-liusb.rules
%if 0%{?_with_systemd}
%{_unitdir}/%{name}.service
%else
%{_initrddir}/srcpd
%endif
%{?el5:%lang(de) %{_mandir}/de/man5/*.5*}
%{?el5:%lang(de) %{_mandir}/de/man8/*.8*}
%{_sbindir}/srcpd
%{_mandir}/man5/*.5*
%{_mandir}/man8/*.8*


%changelog
* Mon Aug 18 2014 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 2.1.2-5
- Rebuilt for https://fedoraproject.org/wiki/Fedora_21_22_Mass_Rebuild

* Mon Jun 30 2014 Jakub Čajka <jcajka@redhat.com> - 2.1.2-4
- Changed exclude to exclusive arch %{ix86} %{arm} x86_64

* Fri Jun 27 2014 Denis Fateyev <denis@fateyev.com> - 2.1.2-3
- Exclude ppc, ppc64 arch from build

* Thu Jun 26 2014 Denis Fateyev <denis@fateyev.com> - 2.1.2-2
- Package spec cleanup

* Sat Feb 08 2014 Denis Fateyev <denis@fateyev.com> - 2.1.2-1
- Initial Fedora RPM release
